<div class="mt-3 blocks mainContainer">
  <div class="container-fluid">
    <form #dataLayoutForm="ngForm" class="card-body">
      <ejs-grid #thresholdListGrid [dataSource]="thresholdRules" height="245" [allowPaging]="true" [allowSorting]="true"
        [allowResizing]="true" [allowReordering]="true" [showColumnChooser]="true" [toolbar]="toolbar">
        <e-columns>
          <e-column field="data_layer_id" headerText={{threshold.ruleListColumn.objLayerNm}}>
          </e-column>
          <e-column field="obj_nm" headerText={{threshold.ruleListColumn.objNm}} isPrimaryKey="true">
          </e-column>
          <e-column field="attr_nm" headerText="{{threshold.ruleListColumn.columnName}}">
          </e-column>
          <e-column field="visual_desc" headerText="{{threshold.ruleListColumn.ruleType}}">
          </e-column>
          <e-column field="bk_attr_nm" headerText="{{threshold.ruleListColumn.reportCols}}">
          </e-column>
          <e-column field="rule_desc" headerText="{{threshold.ruleListColumn.ruleDescription}}">
          </e-column>
          <e-column field="actv_disp" headerText="{{threshold.ruleListColumn.status}}">
          </e-column>
          <e-column field="rule_svrt" headerText="{{threshold.ruleListColumn.severity}}">
          </e-column>
          <e-column headerText="Commands" [commands]="commands">
          </e-column>
        </e-columns>
      </ejs-grid>
    </form>
  </div>
</div>
<div class="mt-0 mr-4 float-right">
  <button name="btnAddNewRule" #btnAddNewRule (click)="addNewThresholdRule()"
    class="btn btn-outline-warning actionButton"
    [disabled]="!dataQualityDetails.obj_id || dataQualityDetails.obj_id===0">
    {{threshold.buttons.addNewRule}}</button>
</div>
<ejs-dialog #addNewThresholdRuleDialog
  [header]="isRuleEditMode?threshold.dialogForm.editRuleHeader:threshold.dialogForm.addRuleHeader"
  [buttons]="dlgButtons" [visible]="false" [isModal]="true" [position]="position">
  <ng-template #content>
    <form ngForm #addNewThresholdRuleForm="ngForm" class="card-body">
      <div class="blocks">
        <p class="custom-h6 col-md-4">{{threshold.dataLayer.title}}</p>
        <ejs-dropdownlist name="selectLayer" #selectLayer="ngModel" [(ngModel)]="thDetails.data_layer_id"
          [dataSource]="businessLayerList" [fields]="businessLayerFields" (change)=dataLayerChange($event) cssClass=""
          class="mr-6 custom-ddl" [placeholder]="threshold.selectOptionWaterMark" disabled>
        </ejs-dropdownlist>
      </div>
      <div class="blocks">
        <p class="custom-h6 col-md-4">{{threshold.object.title}}</p>
        <ejs-dropdownlist name="selectObject" #selectObject="ngModel" [(ngModel)]="thDetails.obj_id"
          [dataSource]="objectList" [fields]="objectFields" (change)="objectChange($event)" cssClass=""
          class="mr-6 custom-ddl" [placeholder]="threshold.selectOptionWaterMark" disabled>
        </ejs-dropdownlist>
      </div>
      <div class="blocks">
        <p class="custom-h6 col-md-4">{{threshold.checkType.title}}<span class="mandatory"> *</span></p>
        <ejs-dropdownlist required name="checkType" #checkType="ngModel" [(ngModel)]="thDetails.mstr_rule_id"
          [dataSource]="checkList" [fields]="checkFields" (change)=checkTypeChange($event) value="SUM VARIATION CHECK" cssClass="e-outline"
          class="mr-6 custom-ddl" [placeholder]="threshold.selectOptionWaterMark" [disabled]="isRuleEditMode"
          [ngClass]="checkType.invalid && (checkType.touched || formInvalidAfterSaveClick)?'error-control-highlight':''">
        </ejs-dropdownlist>
        <ejs-tooltip id="tooltip" content={{threshold.checkType.subtitle}}>
          <em class="fa fa-info-circle"
            [ngClass]="checkType.invalid && (checkType.touched || formInvalidAfterSaveClick)?'error-info-highlight':''"></em>
        </ejs-tooltip>
      </div>

      <div *ngIf="activeCheckType!=='COUNT VARIATION CHECK'">
        <div *ngIf="activeCheckType!=='ATTRIBUTE VARIATION CHECK'">
          <div *ngIf="activeCheckType!=='SUM VARIATION CHECK'">
            <div class="blocks">
              <p class="custom-h6 col-md-4">{{threshold.attribute.title}}<span class="mandatory"> *</span></p>
              <ejs-dropdownlist required name="attribute" #attribute="ngModel" [(ngModel)]="thDetails.attr_id"
                [dataSource]="activeCheckType==='ATTRIBUTE TREND ANALYSIS'?timePeriodAttrList:attributeList" [fields]="attributeFields" (change)="attributeChange($event)"
                cssClass="e-outline" class="mr-6 custom-ddl" [placeholder]="threshold.selectOptionWaterMark"
                [disabled]="isRuleEditMode"
                [ngClass]="attribute.invalid && (attribute.touched || formInvalidAfterSaveClick)?'error-control-highlight':''">
              </ejs-dropdownlist>
              <ejs-tooltip id="tooltip" content={{threshold.attribute.subtitle}}>
                <em class="fa fa-info-circle"
                  [ngClass]="attribute.invalid && (attribute.touched || formInvalidAfterSaveClick)?'error-info-highlight':''"></em>
              </ejs-tooltip>
            </div>
          </div>
          <div *ngIf="activeCheckType==='SUM VARIATION CHECK'">
            <div class="blocks">
              <p class="custom-h6 col-md-4">{{threshold.attribute.title}}<span class="mandatory"> *</span></p>
              <ejs-multiselect name="attribute" #attribute="ngModel" [(ngModel)]="thDetails.attr_id"
              [dataSource]="attributeList" [fields]="attributeFields" (change)="multiAttributeSelected($event)"
                mode="CheckBox" showSelectAll="true" cssClass="e-outline" class="mr-6 custom-ddl" selectAllText="Select All" 
                [placeholder]="threshold.selectOptionWaterMark">
              </ejs-multiselect>
              <ejs-tooltip id="tooltip" content={{threshold.attribute.subtitle}}>
                <em class="fa fa-info-circle"
                  [ngClass]="attribute.invalid && (attribute.touched || formInvalidAfterSaveClick)?'error-info-highlight':''"></em>
              </ejs-tooltip>
            </div>
          </div>
        </div>
        <div class="blocks">
          <p class="custom-h6 col-md-4">{{threshold.reportCols.title}}<span class="mandatory"> *</span></p>
          <ejs-multiselect required name="reportingColumns" #reportingColumns="ngModel" [(ngModel)]="thDetails.bk_attr_id"
            [dataSource]="activeCheckType==='ATTRIBUTE VARIATION CHECK'?attributeList:reportColList" [fields]="attributeFields" 
            (change)="reportColsChange($event)" mode="Default" [placeholder]="threshold.selectOptionWaterMark" width="250px" cssClass="e-outline"></ejs-multiselect>
          <ejs-tooltip id="tooltip" content={{threshold.reportCols.subtitle}}>
            <em class="fa fa-info-circle"></em></ejs-tooltip>
        </div>
        <div class="blocks">
          <p class="custom-h6 col-md-4">{{threshold.aggFunction.title}}<span class="mandatory"> *</span></p>
          <ejs-dropdownlist required width="250px" class="mr-6" name="aggFunction" #aggFunction="ngModel"
            [(ngModel)]="thDetails.agg_fn" cssClass="e-outline" [dataSource]="aggFuncList" [fields]="aggFuncList"
            [placeholder]="threshold.selectOptionWaterMark"
            [ngClass]="aggFunction.invalid && (aggFunction.touched || formInvalidAfterSaveClick)?'error-control-highlight':''">
          </ejs-dropdownlist>
          <ejs-tooltip id="tooltip" content={{threshold.aggFunction.subtitle}}>
            <em class="fa fa-info-circle"
              [ngClass]="aggFunction.invalid && (aggFunction.touched || formInvalidAfterSaveClick)?'error-info-highlight':''"></em>
          </ejs-tooltip>
        </div>
      </div>

      <div class="blocks">
        <p class="custom-h6 col-md-4">{{threshold.thresholdLimit.title}}<span class="mandatory"> *</span></p>
        <ejs-numerictextbox required name="thLimit" #thLimit="ngModel" [(ngModel)]="thDetails.th_val" required
          cssClass="e-outline" floatLabelType="Auto" min="0" max="100" value="10"
          [ngClass]="thLimit.invalid && (thLimit.touched || formInvalidAfterSaveClick)?'error-control-highlight':''">
        </ejs-numerictextbox>
        <ejs-tooltip id="tooltip" content={{threshold.thresholdLimit.subtitle}}>
          <em class="fa fa-info-circle"
            [ngClass]="thLimit.invalid && (thLimit.touched || formInvalidAfterSaveClick)?'error-info-highlight':''"></em>
        </ejs-tooltip>
      </div>
      <div class="blocks">
        <p class="custom-h6 col-md-4">{{threshold.condition.title}}</p>
        <ejs-textbox name="condition" #condition="ngModel" [(ngModel)]="thDetails.fltr_con"
          [placeholder]="threshold.condition.title" cssClass="e-outline" class="mr-6 custom-textbox">
        </ejs-textbox>
        <ejs-tooltip id="tooltip" content={{threshold.condition.subtitle}}>
          <em class="fa fa-info-circle"></em></ejs-tooltip>
      </div>
      <div class="blocks">
        <p class="custom-h6 col-md-4">{{threshold.description.title}}</p>
        <ejs-textbox name="description" #description="ngModel" [(ngModel)]="thDetails.rule_desc" autofocus
          [placeholder]="threshold.description.title" cssClass="e-outline" class="mr-6 custom-textbox">
        </ejs-textbox>
        <ejs-tooltip id="tooltip" content={{threshold.description.subtitle}}>
          <em class="fa fa-info-circle"></em></ejs-tooltip>
      </div>
      <div class="blocks">
        <p class="custom-h6 col-md-4">{{threshold.status.title}}</p>
        <ul class="checkbox-container">
          <li class="checkbox-inline mr-2">
            <ejs-checkbox [label]="threshold.status.label" name="active" #active="ngModel"
              [(ngModel)]="thDetails.is_rule_actv" [value]="status" [disabled]="!isRuleEditMode">
            </ejs-checkbox>
          </li>
        </ul>
      </div>
      <div class="blocks">
        <p class="custom-h6 col-md-4">{{threshold.severity.title}}</p>
        <ul class="checkbox-container">
          <li *ngFor="let severityOption of severityOptions" class="checkbox-inline mr-2">
            <ejs-checkbox label="{{severityOption}}" name="severity" #severity="ngModel"
              [(ngModel)]="thDetails.rule_svrt" value="{{severityOption}}"
              (click)="thDetails.rule_svrt = severityOption">
            </ejs-checkbox>
          </li>
        </ul>
      </div>
    </form>
  </ng-template>
</ejs-dialog>